package br.jus.cnj.selointegracaoclient;

import java.io.File;
import java.net.URL;
import java.util.Random;

import javax.ws.rs.core.MediaType;

import org.apache.log4j.Logger;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.api.client.filter.HTTPBasicAuthFilter;
import com.sun.jersey.multipart.FormDataMultiPart;
import com.sun.jersey.multipart.MultiPart;
import com.sun.jersey.multipart.file.FileDataBodyPart;
import com.sun.jersey.multipart.impl.MultiPartWriter;

public class ClientXML {

	private static final Logger log = Logger.getLogger(ClientXML.class);
	
	public static void main(String[] args) throws Exception {
		// Comando: Deletar o arquivo cacerts 
		// keytool -import -trustcacerts -file "C:\Program Files\Java\jdk1.8.0_25\jre\lib\security\cnj.crt" -keystore "C:\Program Files\Java\jdk1.8.0_25\jre\lib\security\cacerts"
		
		// Pasta que contém o certificado
		// C:\Program Files\Java\jdk1.8.0_25\jre\lib\security
		
		//log.info("SAJ G1 ...");
		
		totalProcessos("G1");
		totalProcessos("G2");
		totalProcessos("JE");
		totalProcessos("TR");
		
		enviarProcessosZIP("C:\\Users\\lerioliveira.TJBA\\Desktop\\PROJETOS\\UNIJUDI\\teste","TR");
//		enviarProcessos("C:\\REPLICACAO_NACIONAL\\NOVA_CARGA\\PJE\\TJBA_JE_08012018","JE");
//		enviarProcessos("C:\\REPLICACAO_NACIONAL\\NOVA_CARGA\\PJE\\TJBA_TR_08012018","TR");
//		enviarProcessos("C:\\REPLICACAO_NACIONAL\\NOVA_CARGA\\PROJUDI\\TJBA_JE_08012018","JE");
//		enviarProcessos("C:\\REPLICACAO_NACIONAL\\NOVA_CARGA\\PROJUDI\\TJBA_TR_08012018","TR");
//		enviarProcessos("C:\\REPLICACAO_NACIONAL\\NOVA_CARGA\\SAJSG\\TJBA_G2_08012018","G2");
//		enviarProcessos("C:\\REPLICACAO_NACIONAL\\NOVA_CARGA\\SAJPG\\TJBA_G1_08012018","G1");
		
		
	}
	
	public static void renomearArquivo(File arquivo, String status) {
		
		try {
			
			File file = new File(arquivo.getAbsolutePath()+status);
			arquivo.renameTo(file);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void enviarProcessosZIP(String caminho, String grau) {

		File file = new File(caminho);
		File afile[] = file.listFiles();

		final ClientConfig config = new DefaultClientConfig();
		config.getClasses().add(MultiPartWriter.class);

		final Client client = Client.create(config);
		client.addFilter(new HTTPBasicAuthFilter("TJXX", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"));
		final WebResource resource = client
				.resource("https://wwwh.cnj.jus.br/selo-integracao-web/v1/processos/" + grau);

		totalProcessos(grau);
		int contador = 0;
		for (File arquivo : afile) {
				if(arquivo.getName().indexOf(".zip")!=-1 && arquivo.getName().indexOf("_OK")==-1){
							
							try {
								FileDataBodyPart filePart = new FileDataBodyPart("file", new File(arquivo.getAbsolutePath()),
										new MediaType("application","x-zip-compressed"));
				
								MultiPart multiPart = new FormDataMultiPart().bodyPart(filePart);
								ClientResponse response = resource.type("multipart/form-data").post(ClientResponse.class, multiPart);
								String retorno = response.getEntity(String.class);
								log.info("("+(++contador)+")"+retorno + " > " + arquivo.getName());
								
								if(!(retorno.indexOf("XML incoerente")!=-1 || retorno.indexOf("<html><head>")!=-1)){
									renomearArquivo(arquivo, "_OK");
								}

								
								
								
							} catch (Exception e) {
								log.info(arquivo.getName() + " não foi enviado!");
								renomearArquivo(arquivo, "_ERRO");
							}
				}
		}

		client.destroy();
		totalProcessos(grau);
	}
	
	public static void enviarProcessosXML(String caminho, String grau) {

		File file = new File(caminho);
		File afile[] = file.listFiles();

		final ClientConfig config = new DefaultClientConfig();
		config.getClasses().add(MultiPartWriter.class);

		final Client client = Client.create(config);
		client.addFilter(new HTTPBasicAuthFilter("TJXX", "XXXXXXXXXXXXXXXXXXXXX"));
		final WebResource resource = client
				.resource("https://wwwh.cnj.jus.br/selo-integracao-web/v1/processos/" + grau);

		totalProcessos(grau);
		int contador = 0;
		for (File arquivo : afile) {
				if(arquivo.getName().indexOf(".xml")!=-1 && arquivo.getName().indexOf("_OK")==-1){
							
							try {
								FileDataBodyPart filePart = new FileDataBodyPart("file", new File(arquivo.getAbsolutePath()),
										MediaType.APPLICATION_OCTET_STREAM_TYPE);
				
								MultiPart multiPart = new FormDataMultiPart().bodyPart(filePart);
								multiPart.setMediaType(MediaType.MULTIPART_FORM_DATA_TYPE);
				
								ClientResponse response = resource.type("multipart/form-data").post(ClientResponse.class, multiPart);
								String retorno = response.getEntity(String.class);
								log.info("("+(++contador)+")"+retorno + " > " + arquivo.getName());
								
								if(!(retorno.indexOf("XML incoerente")!=-1 || retorno.indexOf("<html><head>")!=-1)){
									renomearArquivo(arquivo, "_OK");
								}
								
							} catch (Exception e) {
								log.info(arquivo.getName() + " não foi enviado!");
								renomearArquivo(arquivo, "_ERRO");
							}
				}
		}

		client.destroy();
		totalProcessos(grau);
	}

	public static void totalProcessos(String grau) {
		try {
			final Client client = Client.create();
			client.addFilter(new HTTPBasicAuthFilter("TJXXX", "XXXXXXXXXXXXX"));

			final WebResource resource = client
					.resource("https://wwwh.cnj.jus.br/selo-integracao-web/v1/processos/total/" + grau);
			ClientResponse response = resource.get(ClientResponse.class);
			log.info(grau+ " ->> "+response.getEntity(String.class));
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
	
	

}
